 /**************************************************************************
 *   Copyright (C) 2009 by Silicium628 (France)                            *
 *   http://silicium628.chez-alice.fr/                                     *
 *   http://www.silicium628.fr/                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation;                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY;                                             *
 *   See the GNU General Public License for more details.                  *
 ***************************************************************************/

#include "vecteur3d.h"
#include "complexe.h"
#include <math.h>
//
void Vecteur3D::multi_lambda(double lambda) // produit par un réel
{ 
	x *= lambda;
	y *= lambda;
	z *= lambda;
}

Vecteur3D Vecteur3D::operator+ (Vecteur3D &c)
{
	Vecteur3D r;
	r.x=this->x+c.x;
	r.y=this->y+c.y;
	r.z=this->z+c.y;
	return r;
}

Vecteur3D Vecteur3D::operator- (Vecteur3D &c)
{
	Vecteur3D r;
	r.x=this->x-c.x;
	r.y=this->y-c.y;
	r.z=this->z-c.y;
	return r;
}

Vecteur3D Vecteur3D::operator* (Vecteur3D &c) // produit vectoriel
{
	Vecteur3D r;
	r.x=this->y * c.z - this->z * c.y;
	r.y=this->z * c.x - this->x * c.z;
	r.z=this->x * c.y - this->y * c.x;
	return r;
}


void Vecteur3D::RotX  (double angle)
// rotation autour de l'axe x, angle en radians
{
	Complexe c1,c2, r;

	c1.a=this->y;     c1.b=this->z;	//on forme un nb complexe avec les 2 autres composantes
	r.a=cos(angle);   r.b=sin(angle);
	c2=c1.operator *(r);			//rotation
	this->y=c2.a;     this->z=c2.b;
}


void Vecteur3D::RotY  (double angle)
// rotation autour de l'axe y, angle en radians
{
	Complexe c1,c2, r;

	c1.a=this->z;     c1.b=this->x;	//on forme un nb complexe avec les 2 autres composantes
	r.a=cos(angle);   r.b=sin(angle);
	c2=c1.operator *(r);			//rotation
	this->z=c2.a;     this->x=c2.b;
}


void Vecteur3D::RotZ  (double angle)
// rotation autour de l'axe z, angle en radians
{
	Complexe c1,c2, r;

	c1.a=this->x;     c1.b=this->y;	//on forme un nb complexe avec les 2 autres composantes
	r.a=cos(angle);   r.b=sin(angle);
	c2=c1.operator *(r);			//rotation
	this->x=c2.a;     this->y=c2.b;
}

